/*
 * This software is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 *
 * Autore: Antonino Iacono ant_iacono@tin.it
 *
 */

#include <gtk/gtk.h>

static GdkPixmap *pixmap = NULL;

static gint configure_event( GtkWidget         *widget,
                             GdkEventConfigure *event )
{

GdkPoint points[13];
GdkPoint points2[7];
GdkPoint points3[13];
GdkPoint points4[7];

gint coordX[]={0,3,6,3,0,2,4,2,0,1,2,1,0};
gint coordY[]={3,0,3,6,3,1,3,5,3,2,3,4,3};
gint coordX1[]={2,4,5,4,5,4,2};
gint coordY1[]={3,1,2,3,4,5,3};

gint h;
gint ax1=40;

for(h=0;h<=12;h++) points[h].x=coordX[h]*ax1;
for(h=0;h<=12;h++) points[h].y=coordY[h]*ax1;
for(h=0;h<=6;h++) points2[h].x=coordX1[h]*ax1;
for(h=0;h<=6;h++) points2[h].y=coordY1[h]*ax1;

for(h=0;h<=12;h++) points3[h].x=(coordX[h]*ax1)+ax1*4;
for(h=0;h<=12;h++) points3[h].y=coordY[h]*ax1;
for(h=0;h<=6;h++) points4[h].x=(coordX1[h]*ax1)+ax1*4;
for(h=0;h<=6;h++) points4[h].y=coordY1[h]*ax1;

  if (pixmap) gdk_pixmap_unref(pixmap);

  pixmap = gdk_pixmap_new(widget->window,
			  widget->allocation.width,
			  widget->allocation.height,
			  -1);

  gdk_draw_rectangle (pixmap,
		      widget->style->white_gc,
		      TRUE,
		      0, 0,
		      widget->allocation.width,
		      widget->allocation.height);

  gdk_draw_polygon (pixmap,
		      widget->style->black_gc,
			FALSE,
			points,
			13);

  gdk_draw_polygon (pixmap,
		      widget->style->black_gc,
			FALSE,
			points2,
			7);

  gdk_draw_polygon (pixmap,
		      widget->style->black_gc,
			FALSE,
			points3,
			13);

  gdk_draw_polygon (pixmap,
		      widget->style->black_gc,
			FALSE,
			points4,
			7);

riquadro(widget,0,0);

  return TRUE;
}


extern riquadro (GtkWidget *widget,gint x, gint y)
{
gint *ceno[19];
gchar buf[60];
GtkLabel *label;

static gint ce[]={ 0, 1, 1, 1, 1, 1, 1, 3,1,1,2,2,2,2,2,2,2,2};
static gint mosse=0;
gint b[] = { 0, 6, 4, 2, 8, 6, 4, 10 ,8,6,14,12,16,14,12,18,16,14};
gint a[] = { 0, 2,4,6,4,6,8,6,8,10,2,4,4,6,8,6,8,10};
gint h1;
gint h;
gint shift=40;
gint cella=0;
gint libero=0;
gint cella2=0;

gint var1[]={0,2,5,2,7,7,5,4,5,5,11,7,11,7,8,12,14,14};
gint var2[]={0,4,4,5,5,2,8,5,7,6,12,14,13,11,7,13,13,13};
gint var3[]={0,5,3,6,11,3,2,8,14,8,13,4,10,12,13,16,15,16};
gint var4[]={0,0,1,0,8,4,3,11,6,0,0,13,15,10,11,0,12,0};
gint var5[]={0,0,6,0,1,6,9,13,9,0,0,12,16,15,16,0,17,0};
gint var6[]={0,0,0,0,2,1,0,14,4,0,0,10,0,14,17,0,0,0};
gint var7[]={0,0,0,0,0,8,0,0,0,0,0,0,0,16,0,0,0,0};
gint var8[]={0,0,0,0,0,9,0,0,0,0,0,0,0,17,0,0,0,0};

gint var9[]={0,3,8,1,14,13,4,1,2,1,7,8,4,5,6,10,8,7};
gint var10[]={0,7,11,7,6,0,14,3,11,3,15,16,14,0,4,7,11,10};
gint var11[]={0,9,0,9,12,0,0,9,16,7,17,2,0,0,12,17,0,15};
gint var12[]={0,0,0,0,0,0,0,10,0,0,0,0,0,0,0,0,0,0};
gint var13[]={0,0,0,0,0,0,0,15,0,0,0,0,0,0,0,0,0,0};
gint var14[]={0,0,0,0,0,0,0,17,0,0,0,0,0,0,0,0,0,0};
gint var15[]={0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0};
gint var16[]={0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0};

ceno[1]=var1;
ceno[2]=var2;
ceno[3]=var3;
ceno[4]=var4;
ceno[5]=var5;
ceno[6]=var6;
ceno[7]=var7;
ceno[8]=var8;
ceno[9]=var9;
ceno[10]=var10;
ceno[11]=var11;
ceno[12]=var12;
ceno[13]=var13;
ceno[14]=var14;
ceno[15]=var15;
ceno[16]=var16;


if (x==0 && y==0)
{
        for(h = 1; h <= 17; h++)
        {
            if(ce[h] == 1)	pedina(widget,b[h]*20-20,a[h]*20-20,0xFF0000);
            if(ce[h] == 2)	pedina(widget,b[h]*20-20,a[h]*20-20,0x0000FF);
            if(ce[h] == 3)	vuoto(widget,b[h]*20-20,a[h]*20-20);
	}
return;
}



for(h = 1; h <= 17; h++) if(x >= (b[h] / 2 - 1) * shift + 21 && x <= (b[h] / 2 - 1) * shift + 60 && y >= (a[h] / 2 - 1) * shift + 21 && y <= (a[h] / 2 - 1) * shift + 60)  cella = h;

if (cella==0) return;

if(ce[cella] == 1 || ce[cella]==2) cella2=0;

for(h1 = 1; h1 <= 8; h1++)
{
	if (ce[ceno[h1][cella]]==3)
	{
	cella2=ceno[h1][cella];
	libero=1;
	}
		if (ce[ceno[h1+8][cella]]==3 && (ce[ceno[h1][cella]]==1 || ce[ceno[h1][cella]]==2))
		{
		cella2=ceno[h1+8][cella];
		libero=1;
		}
}

        if(libero==1)
        {
            	ce[cella2] = ce[cella];
  		ce[cella] = 3;

        for(h = 1; h <= 17; h++)
        {
            if(ce[h] == 1)	pedina(widget,b[h]*20-20,a[h]*20-20,0xFF0000);
            if(ce[h] == 2)	pedina(widget,b[h]*20-20,a[h]*20-20,0x0000FF);
            if(ce[h] == 3)	vuoto(widget,b[h]*20-20,a[h]*20-20);
	}

            mosse++;

if(ce[1]==2 && ce[2]==2 &&  ce[3]==2 && ce[4]==2 && ce[5]==2 && ce[6]==2 && ce[7]==3 && ce[8]==2 && ce[9]==2 && ce[10]==1 && ce[11]==1 && ce[12]==1 && ce[13]==1 && ce[14]==1 && ce[15]==1 && ce[16]==1 && ce[17]==1)
{
  label = GTK_LABEL (gtk_object_get_user_data (GTK_OBJECT (widget)));
  sprintf (buf, "Solitario completato in %d mosse",mosse);
  gtk_label_set_text (label, buf);
}
else
{
  label = GTK_LABEL (gtk_object_get_user_data (GTK_OBJECT (widget)));
  sprintf (buf, "Mossa n. %d", mosse);
  gtk_label_set_text (label, buf);
}
}
}


extern gint vuoto( GtkWidget *widget, gint posiX, gint posiY)
{
GdkRectangle update_rect;
update_rect.x=posiX-10;
update_rect.y=posiY-10;
update_rect.width = 70;
update_rect.height = 70;

posiY+=5;
  gdk_draw_rectangle (pixmap,
		      widget->style->white_gc,
		      TRUE,
		      posiX-1, posiY-1,
		      43,31);

  gtk_widget_draw (widget, &update_rect);

}


extern gint pedina( GtkWidget *widget, gint posiX, gint posiY, gint colore)
{

GdkRectangle update_rect;
GdkWindow* Window=widget->window;
GdkGC* GraphicContext=gdk_gc_new (Window);
gdk_rgb_gc_set_foreground(GraphicContext,colore);


posiY+=5;
update_rect.x=posiX-10;
update_rect.y=posiY-10;
update_rect.width = 60;
update_rect.height = 45;
 
  gdk_draw_rectangle (pixmap,
		      GraphicContext,
		      TRUE,
		      posiX, posiY+7,
		      40,16);

  gdk_draw_rectangle (pixmap,
		      widget->style->black_gc,
		      FALSE,
		      posiX, posiY+8,
		      40,14);


  gdk_draw_arc (pixmap,
		    GraphicContext,
			TRUE,
			posiX,
			posiY,
			40,
			15,
			500,
			10300);

  gdk_draw_arc (pixmap,
		    GraphicContext,
			TRUE,
			posiX,
			posiY-2,
			40,
			15,
			12500,
			10300);

  gdk_draw_arc (pixmap,
		      widget->style->black_gc,
			FALSE,
			posiX,
			posiY,
			40,
			15,
			500,
			10300);

  gdk_draw_arc (pixmap,
		      widget->style->black_gc,
			FALSE,
			posiX,
			posiY-2,
			40,
			15,
			12500,
			10300);

  gdk_draw_line (pixmap,
		      widget->style->white_gc,
			posiX+1,
			posiY+28,
			posiX+40,
			posiY+28	);

  gdk_draw_arc (pixmap,
		    GraphicContext,
			TRUE,
			posiX,
			posiY+14,
			40,
			15,
			12500,
			32300);


  gdk_draw_arc (pixmap,
		      widget->style->black_gc,
			FALSE,
			posiX,
			posiY+14,
			40,
			15,
			12500,
			10300);

  gtk_widget_draw (widget, &update_rect);

return TRUE;
}

static gint expose_event( GtkWidget      *widget,
                          GdkEventExpose *event )
{
  gdk_draw_pixmap(widget->window,
		  widget->style->fg_gc[GTK_WIDGET_STATE (widget)],
		  pixmap,
		  event->area.x, event->area.y,
		  event->area.x, event->area.y,
		  event->area.width, event->area.height);

  return FALSE;
}


static gint button_press_event( GtkWidget      *widget,
                                GdkEventButton *event )
{
  if (event->button == 1 && pixmap != NULL)
    riquadro (widget, event->x, event->y);

  return TRUE;
}





void quit ()
{
  gtk_exit (0);
}

int main( int   argc, 
          char *argv[] )
{
  GtkWidget *table;
  GtkWidget *text;
  GtkWidget *window;
  GtkWidget *drawing_area;
  GtkWidget *vbox;
  GtkWidget *button;
  GtkWidget *label;

  gtk_init (&argc, &argv);

  window = gtk_window_new (GTK_WINDOW_TOPLEVEL);

  vbox = gtk_vbox_new (FALSE, 0);
  gtk_container_add (GTK_CONTAINER (window), vbox);
  gtk_widget_show (vbox);

  gtk_signal_connect (GTK_OBJECT (window), "destroy",
		      GTK_SIGNAL_FUNC (quit), NULL);

  drawing_area = gtk_drawing_area_new ();
  gtk_drawing_area_size (GTK_DRAWING_AREA (drawing_area), 405, 260);
  gtk_box_pack_start (GTK_BOX (vbox), drawing_area, TRUE, TRUE, 0);

  gtk_widget_show (drawing_area);

  gtk_signal_connect (GTK_OBJECT (drawing_area), "expose_event",
		      (GtkSignalFunc) expose_event, NULL);


  gtk_signal_connect (GTK_OBJECT(drawing_area),"configure_event",
		      (GtkSignalFunc) configure_event, NULL);

  gtk_signal_connect (GTK_OBJECT (drawing_area), "button_press_event",
		      (GtkSignalFunc) button_press_event, NULL);

  gtk_widget_set_events (drawing_area, GDK_EXPOSURE_MASK
			 | GDK_LEAVE_NOTIFY_MASK
			 | GDK_BUTTON_PRESS_MASK
			 | GDK_POINTER_MOTION_MASK
			 | GDK_POINTER_MOTION_HINT_MASK);


  label = gtk_label_new("Mossa n.0");


  gtk_box_pack_start (GTK_BOX(vbox), label, TRUE, TRUE, 0);

  gtk_object_set_user_data (GTK_OBJECT (drawing_area), label);

  gtk_widget_show (label);


  table = gtk_table_new (2, 2, FALSE);
  gtk_table_set_row_spacing (GTK_TABLE (table), 0, 2);
  gtk_table_set_col_spacing (GTK_TABLE (table), 0, 2);
  gtk_box_pack_start (GTK_BOX (vbox), table, TRUE, TRUE, 0);
  gtk_widget_show (table);

  text = gtk_text_new (NULL, NULL);

  gtk_table_attach (GTK_TABLE (table), text, 0, 1, 0, 1,
		    GTK_EXPAND | GTK_SHRINK | GTK_FILL,
		    GTK_EXPAND | GTK_SHRINK | GTK_FILL, 0, 0);

  gtk_widget_show (text);

  gtk_widget_realize (text);

  gtk_text_freeze (GTK_TEXT (text));
  
  gtk_text_insert (GTK_TEXT (text), NULL, &text->style->black, NULL,
		   "\nIstruzioni\n\nQuesto semplice solitario si completa spostando le pedine rosse a destra \n e le blu a sinistra, le pedine possono anche saltare le altre.\n\nBuon divertimento da Antonino Iacono (ant_iacono@tin.it)", -1);


  gtk_text_thaw (GTK_TEXT (text));


  button = gtk_button_new_with_label ("Esci");

  gtk_box_pack_start (GTK_BOX (vbox), button, FALSE, FALSE, 0);

  gtk_signal_connect_object (GTK_OBJECT (button), "clicked",
			     GTK_SIGNAL_FUNC (gtk_widget_destroy),
			     GTK_OBJECT (window));

  gtk_widget_show (button);

  gtk_widget_show (window);

  gtk_main ();

  return 0;
}
